// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.internal.component.AbstractUIMessages;
import org.apache.myfaces.tobago.layout.Display;
import org.apache.myfaces.tobago.layout.Measure;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.renderkit.MarginValues;
import org.apache.myfaces.tobago.renderkit.SpacingValues;
import org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Renders error/validation messages.
  * UIComponent class, generated from template {@code component2.0.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.MessagesTagDeclaration}.
 */
public class UIMessages
    extends AbstractUIMessages implements SupportsMarkup {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.Messages";

  public static final String COMPONENT_FAMILY = "javax.faces.Messages";

  private org.apache.myfaces.tobago.context.Markup currentMarkup;

  enum PropertyKeys {
    columnSpan,
    preferredWidth,
    horizontalIndex,
    orderBy,
    preferredHeight,
    marginRight,
    maxNumber,
    top,
    currentWidth,
    maximumWidth,
    currentHeight,
    height,
    rowSpan,
    globalOnly,
    markup,
    display,
    minimumHeight,
    confirmation,
    marginLeft,
    minSeverity,
    left,
    width,
    maximumHeight,
    marginBottom,
    verticalIndex,
    minimumWidth,
    marginTop,
    maxSeverity,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  public java.lang.Integer getColumnSpan() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.columnSpan);
    if (value != null) {
      return value.intValue();
    }
    return 1;
  }

  public void setColumnSpan(java.lang.Integer columnSpan) {
    getStateHelper().put(PropertyKeys.columnSpan, columnSpan);
  }

  public org.apache.myfaces.tobago.layout.Measure getPreferredWidth() {
    Object object = getStateHelper().eval(PropertyKeys.preferredWidth);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getPreferredWidth(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPreferredWidth(org.apache.myfaces.tobago.layout.Measure preferredWidth) {
    getStateHelper().put(PropertyKeys.preferredWidth, preferredWidth);
  }

  /**
  This attribute is for internal use only.

  */
  public java.lang.Integer getHorizontalIndex() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.horizontalIndex);
    if (value != null) {
      return value.intValue();
    }
    return null;
  }

  public void setHorizontalIndex(java.lang.Integer horizontalIndex) {
    getStateHelper().put(PropertyKeys.horizontalIndex, horizontalIndex);
  }

  /**
  Sets the order of the messages.
  <br />Default: <code>occurrence</code><br />Allowed Values: <code>occurrence,severity</code>
  */
  public org.apache.myfaces.tobago.component.UIMessages.OrderBy getOrderBy() {
    org.apache.myfaces.tobago.component.UIMessages.OrderBy orderBy = (org.apache.myfaces.tobago.component.UIMessages.OrderBy) getStateHelper().eval(PropertyKeys.orderBy);
    if (orderBy != null) {
      return orderBy;
    }
    return org.apache.myfaces.tobago.internal.component.AbstractUIMessages.OrderBy.OCCURRENCE;
  }

  public void setOrderBy(org.apache.myfaces.tobago.component.UIMessages.OrderBy orderBy) {
    getStateHelper().put(PropertyKeys.orderBy, orderBy);
  }

  public org.apache.myfaces.tobago.layout.Measure getPreferredHeight() {
    Object object = getStateHelper().eval(PropertyKeys.preferredHeight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getPreferredHeight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPreferredHeight(org.apache.myfaces.tobago.layout.Measure preferredHeight) {
    getStateHelper().put(PropertyKeys.preferredHeight, preferredHeight);
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginRight() {
    Object object = getStateHelper().eval(PropertyKeys.marginRight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginRight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMarginRight(org.apache.myfaces.tobago.layout.Measure marginRight) {
    getStateHelper().put(PropertyKeys.marginRight, marginRight);
  }

  /**
  Sets the maximum number of messages to show.
  <br />Default: <code>2147483647</code>
  */
  public java.lang.Integer getMaxNumber() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.maxNumber);
    if (value != null) {
      return value.intValue();
    }
    return 2147483647;
  }

  public void setMaxNumber(java.lang.Integer maxNumber) {
    getStateHelper().put(PropertyKeys.maxNumber, maxNumber);
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getTop() {
    Object object = getStateHelper().eval(PropertyKeys.top);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return null;
  }

  public void setTop(org.apache.myfaces.tobago.layout.Measure top) {
    getStateHelper().put(PropertyKeys.top, top);
  }

  /**
  This value will usually be set by the layout manager. It holds the current width computed by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getCurrentWidth() {
    Object object = getStateHelper().eval(PropertyKeys.currentWidth);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getWidth();
  }

  public void setCurrentWidth(org.apache.myfaces.tobago.layout.Measure currentWidth) {
    getStateHelper().put(PropertyKeys.currentWidth, currentWidth);
  }

  public org.apache.myfaces.tobago.layout.Measure getMaximumWidth() {
    Object object = getStateHelper().eval(PropertyKeys.maximumWidth);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMaximumWidth(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMaximumWidth(org.apache.myfaces.tobago.layout.Measure maximumWidth) {
    getStateHelper().put(PropertyKeys.maximumWidth, maximumWidth);
  }

  /**
  This value will usually be set by the layout manager. It holds the current height computed by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getCurrentHeight() {
    Object object = getStateHelper().eval(PropertyKeys.currentHeight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getHeight();
  }

  public void setCurrentHeight(org.apache.myfaces.tobago.layout.Measure currentHeight) {
    getStateHelper().put(PropertyKeys.currentHeight, currentHeight);
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getHeight() {
    Object object = getStateHelper().eval(PropertyKeys.height);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getHeight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setHeight(org.apache.myfaces.tobago.layout.Measure height) {
    getStateHelper().put(PropertyKeys.height, height);
  }

  public java.lang.Integer getRowSpan() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.rowSpan);
    if (value != null) {
      return value.intValue();
    }
    return 1;
  }

  public void setRowSpan(java.lang.Integer rowSpan) {
    getStateHelper().put(PropertyKeys.rowSpan, rowSpan);
  }

  /**
  Flag indicating that only messages that are not associated to any particular UIComponent should be displayed. That
   are messages without clientId.
  <br />Default: <code>false</code>
  */
  public java.lang.String getGlobalOnly() {
    java.lang.String globalOnly = (java.lang.String) getStateHelper().eval(PropertyKeys.globalOnly);
    if (globalOnly != null) {
      return globalOnly;
    }
    return "false";
  }

  public void setGlobalOnly(java.lang.String globalOnly) {
    getStateHelper().put(PropertyKeys.globalOnly, globalOnly);
  }

  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Display getDisplay() {
    return (org.apache.myfaces.tobago.layout.Display) getStateHelper().eval(PropertyKeys.display);
  }

  public void setDisplay(org.apache.myfaces.tobago.layout.Display display) {
    getStateHelper().put(PropertyKeys.display, display);
  }

  public org.apache.myfaces.tobago.layout.Measure getMinimumHeight() {
    Object object = getStateHelper().eval(PropertyKeys.minimumHeight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMinimumHeight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMinimumHeight(org.apache.myfaces.tobago.layout.Measure minimumHeight) {
    getStateHelper().put(PropertyKeys.minimumHeight, minimumHeight);
  }

  /**
  Has the user to confirm this message? This attributes handles the case, if the application wants to warn the user
   about a problem, and the user has to confirm the message before he/she can continue.
  <br />Default: <code>false</code>
  */
  public boolean isConfirmation() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.confirmation);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setConfirmation(boolean confirmation) {
    getStateHelper().put(PropertyKeys.confirmation, confirmation);
  }

  public org.apache.myfaces.tobago.context.Markup getCurrentMarkup() {
    if (currentMarkup != null) {
      return currentMarkup;
    }
    return null;
  }

  public void setCurrentMarkup(org.apache.myfaces.tobago.context.Markup currentMarkup) {
    this.currentMarkup = currentMarkup;
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginLeft() {
    Object object = getStateHelper().eval(PropertyKeys.marginLeft);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginLeft(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMarginLeft(org.apache.myfaces.tobago.layout.Measure marginLeft) {
    getStateHelper().put(PropertyKeys.marginLeft, marginLeft);
  }

  /**
  Sets the mininum severity to be shown. E. g. "warn" shows only "warn", "error" and "fatal".
  <br />Default: <code>info</code>
  */
  public javax.faces.application.FacesMessage.Severity getMinSeverity() {
    javax.faces.application.FacesMessage.Severity minSeverity = (javax.faces.application.FacesMessage.Severity) getStateHelper().eval(PropertyKeys.minSeverity);
    if (minSeverity != null) {
      return minSeverity;
    }
    return javax.faces.application.FacesMessage.SEVERITY_INFO;
  }

  public void setMinSeverity(javax.faces.application.FacesMessage.Severity minSeverity) {
    getStateHelper().put(PropertyKeys.minSeverity, minSeverity);
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getLeft() {
    Object object = getStateHelper().eval(PropertyKeys.left);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return null;
  }

  public void setLeft(org.apache.myfaces.tobago.layout.Measure left) {
    getStateHelper().put(PropertyKeys.left, left);
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getWidth() {
    Object object = getStateHelper().eval(PropertyKeys.width);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getWidth(getFacesContext(), this) : Measure.ZERO;
  }

  public void setWidth(org.apache.myfaces.tobago.layout.Measure width) {
    getStateHelper().put(PropertyKeys.width, width);
  }

  public org.apache.myfaces.tobago.layout.Measure getMaximumHeight() {
    Object object = getStateHelper().eval(PropertyKeys.maximumHeight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMaximumHeight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMaximumHeight(org.apache.myfaces.tobago.layout.Measure maximumHeight) {
    getStateHelper().put(PropertyKeys.maximumHeight, maximumHeight);
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginBottom() {
    Object object = getStateHelper().eval(PropertyKeys.marginBottom);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginBottom(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMarginBottom(org.apache.myfaces.tobago.layout.Measure marginBottom) {
    getStateHelper().put(PropertyKeys.marginBottom, marginBottom);
  }

  /**
  This attribute is for internal use only.

  */
  public java.lang.Integer getVerticalIndex() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.verticalIndex);
    if (value != null) {
      return value.intValue();
    }
    return null;
  }

  public void setVerticalIndex(java.lang.Integer verticalIndex) {
    getStateHelper().put(PropertyKeys.verticalIndex, verticalIndex);
  }

  public org.apache.myfaces.tobago.layout.Measure getMinimumWidth() {
    Object object = getStateHelper().eval(PropertyKeys.minimumWidth);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMinimumWidth(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMinimumWidth(org.apache.myfaces.tobago.layout.Measure minimumWidth) {
    getStateHelper().put(PropertyKeys.minimumWidth, minimumWidth);
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginTop() {
    Object object = getStateHelper().eval(PropertyKeys.marginTop);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginTop(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMarginTop(org.apache.myfaces.tobago.layout.Measure marginTop) {
    getStateHelper().put(PropertyKeys.marginTop, marginTop);
  }

  /**
  Sets the maximum severity to be shown. E. g. "warn" shows only "warn" and "info". When setting this attribute you
   usually shoud take care, that you have a second message tag to show the higher severity levels.
  <br />Default: <code>fatal</code>
  */
  public javax.faces.application.FacesMessage.Severity getMaxSeverity() {
    javax.faces.application.FacesMessage.Severity maxSeverity = (javax.faces.application.FacesMessage.Severity) getStateHelper().eval(PropertyKeys.maxSeverity);
    if (maxSeverity != null) {
      return maxSeverity;
    }
    return javax.faces.application.FacesMessage.SEVERITY_FATAL;
  }

  public void setMaxSeverity(javax.faces.application.FacesMessage.Severity maxSeverity) {
    getStateHelper().put(PropertyKeys.maxSeverity, maxSeverity);
  }

  public Object saveState(FacesContext context) {
    currentMarkup = null;
    return super.saveState(context);
  }

}